#include <iostream>
#include "../util/StackLinkedListArray.h"

using namespace std;

int main(int, char**)
{
    char c; Stack<int> acc(50); int x;
    try {
	while (cin.get(c))
	{
	    x = 0;
	    while (c == ' ' || c == '\n')
		if (!cin.get(c)) goto out;
	    if (c == '+') x = acc.pop() + acc.pop();
	    if (c == '*') x = acc.pop() * acc.pop();
	    while (c>='0' && c<='9')
	    {
		x = 10*x + (c-'0');
		if (!cin.get(c)) goto out;
	    }
	    acc.push(x);
	}
    out:
	cout << acc.pop() << '\n';
    }
    catch(exception &e)
    {
	cerr << "Error: " << e.what() << endl;
    }
}
