#include <iostream>
#include "list.h"

using namespace std;

void read() {
	char c;
	node_t *end = head;
	while ( cin.get( c ) ) {
		if ( c != ' ' )
			end = insert_after( end, c );
	}
}

node_t * insert_after( node_t *t, int v ) {
	struct node_t *n = new node_t;
	n->key = v; n->next = t->next;
	t->next = n;
	
	return n;
}

void print( node_t *t ) {
	while ( t != z ) {
		cout << t->key << ' ';
		t = t->next;
	}	
	cout << endl;
}

void selectionSort() {
	node_t *ip, *minp, *jp;
	ip = head;
	while ( ip->next != z ) {
		minp = ip;
		jp = ip->next;
		while ( jp != z ) {
			if ( jp->key < minp->key )
				minp = jp; 	
			jp = jp->next;
		}
		swapkeys( minp, ip );
		//swap( minp, ip );
		ip = ip->next;
	}
}

// swap doesn't seemt to want to work. I have tried this algorithm 4 different ways
// and nothing seems to happen with it.
void swap( node_t *mp, node_t *ip ) {
	node_t *tmp;
	tmp->next = ip->next;

	ip->next = mp->next;
	tmp->next->next = mp->next->next;
	ip->next->next = tmp->next;
	
	delete tmp;
}

// swapkeys was included to at least show you that my sorting algorithm works
void swapkeys( node_t * m, node_t * n ) {
	node_t * temp;
	temp->key = m->key;
	m->key = n->key;
	n->key = temp->key;
}
	
void kill() {
	struct node_t *t = head;
	while ( t != z ) {
		head = t; t = t->next; delete head;
	}
}

int main( int, char** )
{
	head = new node_t; z = new node_t;
	head->next = z; z->next = z;
	
	read();
	cout << "Unsorted: ";
	print( head->next );	
	selectionSort();
	cout << "Sorted:   "; 
	print( head->next );
	kill();	
	
	return 1;	
} 	
