#include <iostream>

#include "../util/Stack.h"
#include "tree.h"

using namespace std;

void visit( node* t ) 
{
    cout << ' ' << t->info << ' ';
}

void traverse0( node *t ) 
{
	if ( t == s_z ) return;
	
	traverse0( t->l );
	traverse0( t->r );
	visit( t );
}

void traverse1( node *t ) 
{
	Stack<node *> stack( 50 );
	b: if ( t == s_z ) goto e;

	   traverse1( t->l );
	   stack.push( t );
	   t = t->r;
	   goto b;
	
	c: visit( t );
	e: if ( !stack.empty() ) {
		t = stack.pop();
		goto c;
	   } 
}

void traverse2( node *t ) 
{
	node *m = new node;
	Stack<node *> stack( 50 );
	stack.push( t );
	l: if ( t == s_z ) goto e;
	  
	   if ( t->l == s_z ) goto r; 
	   stack.push( t ); 
	   stack.push( m ); 
	   stack.push( t->l );
	   t = t-> l;
	   goto l;
	
	r: if ( t->r == s_z ) goto e;
	   stack.push( t->r );	
     	   t = t->r;
	   goto l;
	
	v: visit( t );
	e: if (!stack.empty() ) {
		t = stack.pop();
     		if ( t != m ) 
			goto v;
		else { 
			t = stack.pop();
			goto r;
		}
	   }
}	   


int main( int, char** ) 
{
    try {
	//traverse0( buildTree() ); cout << endl;
	//traverse1( buildTree() ); cout << endl;
	traverse2( buildTree() ); cout << endl;
    }
    catch( exception &e ) {
	cerr << "Error: " << e.what() << endl;
    }
}
